
; extended Win32 programming headers with parameters count checking (WIDE)

include 'win32wx.inc'

macro invoke proc,[arg]
 { common local ..count
    ..count = 0
    if ~ arg eq
   forward ..count = ..count + 1
   common
    end if
    if defined proc#%
     if ..count <> proc#%
      display "error: invalid count of parameters for API call.",0Dh,0Ah
      local halt
      halt
     end if
    end if
    invoke proc,arg }

macro proc name,[arg]
 { common
    if ~ current@proc eq ?
     display "error: procedure ",`current@proc," was not closed.",0Dh,0Ah
     local halt
     halt
    end if
    current@proc fix name
    proc name,arg }

macro endp name
 { if ~ (current@proc eq name | name eq)
    display "error: closing ",`current@proc," is expected here.",0Dh,0Ah
    local halt
    halt
   end if
   current@proc fix ?
   endp }

current@proc fix ?

include 'pcount/kernel32.inc'
include 'pcount/user32.inc'
include 'pcount/gdi32.inc'
include 'pcount/advapi32.inc'
include 'pcount/comctl32.inc'
include 'pcount/comdlg32.inc'
include 'pcount/shell32.inc'
include 'pcount/wsock32.inc'
